library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity datapath_tb is
end datapath_tb;

architecture tb_arch of datapath_tb is
  component datapath
    port (			  
      clk, reset : in std_logic;
			in1, in2, in3, in4 : in std_logic_vector(7 downto 0);
			sel : in std_logic_vector(2 downto 0);
		  outp : out std_logic_vector(7 downto 0)
    );
  end component;
  -- 
  signal clk, reset: std_logic;
	signal in1, in2, in3, in4: std_logic_vector(7 downto 0);
	signal sel: std_logic_vector(2 downto 0);
  signal outp : std_logic_vector(7 downto 0);
  --
  constant CLK_PERIOD : time := 50 ns;
  --
begin

  uut : datapath
    port map (
      clk => clk,
			reset => reset,
			in1 => in1,
			in2 => in2,
			in3 => in3,
			in4 => in4,
			sel => sel,
			outp => outp
    );

  CLK_GEN_PROC: process(clk)
  begin
    if (clk = 'U') then 
      clk <= '1'; 
    else 
      clk <= not clk after CLK_PERIOD/2; 
    end if;
  end process CLK_GEN_PROC;	

  DATA_INPUT: process
	  variable ix : integer range 0 to 7;
  begin
    in1 <= X"DE";
		in2 <= X"AD";
		in3 <= X"BE";
		in4 <= X"EF"; 
		sel <= "000";
		reset <= '1';
		wait for CLK_PERIOD;
		--
		reset <= '0';
		--
		for i in 0 to 7 loop
		  sel <= std_logic_vector(to_unsigned(i,3));
		  wait for CLK_PERIOD;
	  end loop;
		--
  end process DATA_INPUT;

end tb_arch;
