-- 
-- Gia to Modelsim:
-- Kane new project.
-- Bale ws project name "msimex".
-- Xrhsimopoihse work ws Default Library Name. Den peirazeis tipota allo. 
-- # Compile of msimex_tb.vhd was successful.
-- Kane ta ejhs (apo to command prompt tou Modelsim: VSIM 1> )
-- vcom reg_dw.vhd
-- vcom instr_and.vhd
-- vcom instr_xor.vhd
-- vcom instr_add.vhd
-- vcom instr_mov.vhd
-- vcom msimex.vhd
-- vcom msimex_tb.vhd
-- vsim work.msimex_tb(tb_architecture)
-- run
-- # STO SHMEIO AUTO pros8ese ta shmata se ena neo waveform h alliws grapse 
-- thn parakatw entolh add wave
-- add wave \
-- {sim:/msimex_tb/clk } \
-- {sim:/msimex_tb/reset } \
-- {sim:/msimex_tb/vr1 } \
-- {sim:/msimex_tb/vr2 } \
-- {sim:/msimex_tb/vr3 } \
-- {sim:/msimex_tb/vr4 } \
-- {sim:/msimex_tb/vr7 } \
-- {sim:/msimex_tb/vr8 } \
-- {sim:/msimex_tb/vr1_en } \
-- {sim:/msimex_tb/vr2_en } \
-- {sim:/msimex_tb/vr3_en } \
-- {sim:/msimex_tb/vr4_en } \
-- {sim:/msimex_tb/vr7_en } \
-- {sim:/msimex_tb/vr8_en } 
-- restart -f
-- run 
-- run
-- Gia na stamathseis to simulation kane:
-- quit -sim
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_textio.all;
use STD.textio.all;


entity msimex_tb is
  generic (
	  DW     : integer := 32
  );  
end msimex_tb;
                              
                              
architecture tb_architecture of msimex_tb is
--
-- Component declaration of the DUT
component datapath
  generic (
	  DW     : integer := 32
  );  
	port (
	  clk    : in  std_logic;
    reset  : in  std_logic;
		vr1    : in  std_logic_vector(DW-1 downto 0);
		vr2    : in  std_logic_vector(DW-1 downto 0);
		vr3    : in  std_logic_vector(DW-1 downto 0);
		vr4    : in  std_logic_vector(DW-1 downto 0);
		vr7    : out std_logic_vector(DW-1 downto 0);
		vr8    : out std_logic_vector(DW-1 downto 0);
		vr1_en : in  std_logic;
		vr2_en : in  std_logic;
		vr3_en : in  std_logic;
		vr4_en : in  std_logic;
		vr7_en : in  std_logic;
		vr8_en : in  std_logic
  );
end component;
-- 
-- Signal declarations
-- Stimulus signals - signals mapped to the I/IO ports of tested entity
signal clk            : std_logic;
signal reset          : std_logic;
signal vr1            : std_logic_vector(DW-1 downto 0);
signal vr2            : std_logic_vector(DW-1 downto 0);
signal vr3            : std_logic_vector(DW-1 downto 0);
signal vr4            : std_logic_vector(DW-1 downto 0);
signal vr7            : std_logic_vector(DW-1 downto 0);
signal vr8            : std_logic_vector(DW-1 downto 0);
signal vr1_en         : std_logic;
signal vr2_en         : std_logic;
signal vr3_en         : std_logic;
signal vr4_en         : std_logic;
signal vr7_en         : std_logic;
signal vr8_en         : std_logic;
--
-- Constant declarations
constant CLK_PERIOD : time := 10 ns;

begin

  -- Unit Under Test port map
  UUT : datapath
    generic map (    
      DW => DW
    )
    port map (
      clk => clk,
      reset => reset,
	    vr1 => vr1,
			vr2 => vr2,
			vr3 => vr3,
			vr4 => vr4,
			vr7 => vr7,
			vr8 => vr8,
			vr1_en => vr1_en,
			vr2_en => vr2_en,
			vr3_en => vr3_en,
			vr4_en => vr4_en,
			vr7_en => vr7_en,
			vr8_en => vr8_en
    );
    
CLK_GEN_PROC: process(clk)
begin
  if (clk = 'U') then 
    clk <= '1'; 
  else 
    clk <= not clk after CLK_PERIOD/2; 
  end if;
end process CLK_GEN_PROC;	

DATA_STIM: process
begin
  reset <= '0';
  vr1_en <= '0';
  vr2_en <= '0';
  vr3_en <= '0';
  vr4_en <= '0';
  vr7_en <= '0';
  vr8_en <= '0';
  vr1 <= (others => '0');
  vr2 <= (others => '0');
  vr3 <= (others => '0');
  vr4 <= (others => '0');
  vr1 <= (others => '0');
  vr1 <= (others => '0');
  vr1 <= (others => '0');
  vr1 <= (others => '0');
  vr1 <= (others => '0');
	wait for CLK_PERIOD;
  --
  reset <= '1';
  vr1_en <= '1';
  vr2_en <= '1';
  vr3_en <= '1';
  vr4_en <= '1';
  vr7_en <= '1';
  vr8_en <= '1';
  vr1 <= (others => '0');
  vr2 <= (others => '0');
  vr3 <= (others => '0');
  vr4 <= (others => '0');
  vr1 <= (others => '0');
  vr1 <= (others => '0');
  vr1 <= (others => '0');
  vr1 <= (others => '0');
  vr1 <= (others => '0');
	wait for CLK_PERIOD;
  --
  reset  <= '0';
  vr1_en <= '1';
  vr2_en <= '1';
  vr3_en <= '1';
  vr4_en <= '1';
  vr7_en <= '1';
  vr8_en <= '1';
  vr1 <= X"FFFFFF00";
	vr2 <= X"5A5A5A5A";
	vr3 <= X"00FF00FF";
	vr4 <= X"FEDCBA98";
	wait for 3*CLK_PERIOD;
  --
  reset  <= '0';
  vr1_en <= '1';
  vr2_en <= '1';
  vr3_en <= '1';
  vr4_en <= '1';
  vr7_en <= '1';
  vr8_en <= '1';
  vr2 <= X"FFFFFF00";
	vr3 <= X"5A5A5A5A";
	vr4 <= X"00FF00FF";
	vr1 <= X"FEDCBA98";
	wait for 3*CLK_PERIOD;
  --
  reset  <= '0';
  vr1_en <= '1';
  vr2_en <= '1';
  vr3_en <= '1';
  vr4_en <= '1';
  vr7_en <= '1';
  vr8_en <= '1';
  vr3 <= X"FFFFFF00";
	vr4 <= X"5A5A5A5A";
	vr1 <= X"00FF00FF";
	vr2 <= X"FEDCBA98";
	wait for 3*CLK_PERIOD;
  --
  reset  <= '0';
  vr1_en <= '1';
  vr2_en <= '1';
  vr3_en <= '1';
  vr4_en <= '1';
  vr7_en <= '1';
  vr8_en <= '1';
  vr4 <= X"FFFFFF00";
	vr1 <= X"5A5A5A5A";
	vr2 <= X"00FF00FF";
	vr3 <= X"FEDCBA98";
	wait for 3*CLK_PERIOD;
  --
  wait for CLK_PERIOD;
  --            
end process DATA_STIM;

end tb_architecture;
