library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use work.various_pkg.all;

entity muxnto1_tb is
  generic (
    N : integer := 8
  );
end muxnto1_tb;

architecture tb_arch of muxnto1_tb is
  component muxnto1
    generic (
      N : integer := 8
    );
    port (
      inp  : in std_logic_vector(N-1 downto 0);
			sel  : in std_logic_vector(log2c(N)-1 downto 0);
			outp : out std_logic
    );
  end component;
  -- 
  signal inp  : std_logic_vector(N-1 downto 0);
	signal sel  : std_logic_vector(log2c(N)-1 downto 0);
  signal outp : std_logic;
  --
  constant PERIOD : time := 10 ns;
  --
begin

  -- Unit Under Test port map
  muxnto1_uut : muxnto1
    generic map (
      N => N
    )
    port map (
      inp  => inp,
			sel  => sel,
			outp => outp
    );

  DATA_INPUT: process
  begin
    inp <= X"A6";
		--
		for i in 0 to 7 loop
		  sel <= std_logic_vector(to_unsigned(i,log2c(N)));
		  wait for PERIOD;
	  end loop;
  end process DATA_INPUT;

end tb_arch;
