library IEEE;
use IEEE.std_logic_1164.all;

entity regn is	 
  generic (
    N : integer := 16
  );
  port (			  
    clk   : in std_logic;
		reset : in std_logic;
    d     : in std_logic_vector(N-1 downto 0);
    q     : out std_logic_vector(N-1 downto 0)
  );
end regn;

architecture rtl of regn is
signal temp : std_logic_vector(N-1 downto 0);
begin                              
  process (clk, reset, d)
  begin					
    if (reset = '1') then
      temp <= (others => '0');
    elsif (clk'EVENT and clk = '1') then
      temp <= d;
    end if;
  end process;
  q <= temp;
end rtl;
