library IEEE;
use IEEE.std_logic_1164.all;

package various_pkg is
  function LOG2F(input: INTEGER) return INTEGER;
  function LOG2C(input: INTEGER) return INTEGER;
end various_pkg;

package body various_pkg is

  ----------------------------------------------------------------------------
  -- Base-2 logarithm function (LOG2F(x)) [rounds to floor]
  ----------------------------------------------------------------------------
  function LOG2F(input: INTEGER) return INTEGER is
    variable temp,log: INTEGER;
    begin
      temp := input;
      log := 0;
      while (temp > 1) loop
        temp := temp/2;
        log := log+1;
      end loop;
    return (log);
  end function LOG2F;

----------------------------------------------------------------------------
-- Base-2 logarithm function (LOG2C(x)) [rounds to ceiling]
-- Adopted from Reto Zimmermann's "arith_lib" (was: log2ceil)
----------------------------------------------------------------------------
  function LOG2C(input: INTEGER) return INTEGER is
    variable temp,log: INTEGER;
    begin
      log := 0;
      temp := 1;
      for i in 0 to input loop
        if temp < input then
          log := log + 1;
          temp := temp * 2;
        end if;
      end loop;
			return (log);
  end function LOG2C;

end various_pkg;
